﻿package{
	
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.display.DisplayObject;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import fl.transitions.Tween;
 import fl.transitions.easing.*;
	/*Lire la doc pour ColorTransform*/
	import flash.geom.ColorTransform;
	
	public class Branches extends Sprite{
		
		private var stack:Array = new Array();
		private var stylo:Sprite = new Sprite();
		private var sketch:Sprite = new Sprite();
		private var bg:BitmapData;
		private var container:Bitmap;
		private var boule:Ext_sprite;
		private var inc:Number = 0;
		
		public function Branches(){
			/*Creation du bitmapDATA pour  copier nos vecteurs*/
			bg = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x00000000);
			container = new Bitmap(bg);
			addChild(container);
			addChild(sketch);
			/*Affectation des écouteurs de la souris*/
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
			}
		/*Quand on click sur la souris, on efface le trait de repérage, on libère de la mémoire, on affecte l'écouteur sur le mouvement de la souris*/	
		private function downHandler(event:MouseEvent):void{
			stack = new Array();
			stylo.graphics.clear();
			stylo.graphics.lineStyle(1,0x000000,.5);
			stylo.graphics.moveTo(event.currentTarget.mouseX,event.currentTarget.mouseY);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
			}
		/*Quand on bouge la souris, on stock les points, on dessine le repère et on l'ajoute au stage pour le voir*/
		private function moveHandler(event:MouseEvent):void{
			stack.push({'X':event.currentTarget.mouseX,'Y':event.currentTarget.mouseY});
			stylo.graphics.lineTo(event.currentTarget.mouseX,event.currentTarget.mouseY);
			addChild(stylo);
			}
		/*Quand on lache la souris, on dessine des boules tous les 5 points, on leur affect un écouteur ENTER_FRAME et on supprime l'écouteur MOUSE_MOVE*/
		 private function upHandler(event:MouseEvent):void {
			for(var i:Number=0;i<stack.length;i++){
				if(i%5==0){
					inc++;
					boule = new Ext_sprite();
					boule.name = "boule"+inc;
					boule.graphics.beginFill(0x555555,.6);
					boule.graphics.lineStyle(1,0x000000,.20);
					boule.graphics.drawRect (stack[i].X,stack[i].Y,10,10);
					boule.graphics.endFill();
					boule.vx = (1-Math.random()*2) * 3;
					boule.vy = (1-Math.random()*2) * 3;
					boule.stageX=stack[i].X;
					boule.stageY=stack[i].Y;
					boule.addEventListener(Event.ENTER_FRAME,enterHandler);
					sketch.addChild(boule);
					}
				}
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,moveHandler);
			
			}
		/*Function pour faire bouger les boules et les dessiner ds notre BitmapDATA*/
		private function enterHandler(e:Event):void{
				e.currentTarget.vx +=Math.cos( e.currentTarget.vx*Math.PI/180)*(e.currentTarget.vx/12 );
				e.currentTarget.vy +=Math.sin( e.currentTarget.vy*Math.PI/180)*(e.currentTarget.vy/12 )+.15;
				if((e.currentTarget.stageY - e.currentTarget.height/2) > stage.stageHeight || (e.currentTarget.stageX - e.currentTarget.width/2) > stage.stageWidth || (e.currentTarget.stageY + e.currentTarget.height/2) < 0 || (e.currentTarget.stageX + e.currentTarget.width/2) < 0){
					e.currentTarget.removeEventListener(Event.ENTER_FRAME,enterHandler);
					sketch.removeChildAt(sketch.getChildIndex(sketch.getChildByName(e.currentTarget.name)));
				}else{
					e.currentTarget.stageX+=e.currentTarget.vx;
					e.currentTarget.stageY+=e.currentTarget.vy;
					e.currentTarget.x+=e.currentTarget.vx;
					e.currentTarget.y+=e.currentTarget.vy;
					e.currentTarget.width-=.5;
					e.currentTarget.height-=.5;
					e.currentTarget.transform.colorTransform = new ColorTransform( /*Rouge*/ Math.random(),/*Vert*/Math.random(),/*Bleu*/0,Math.random(),0, 1, 0, Math.random());
					bg.draw(sketch);
					 
					
					
				}
			}
		
		}
	}
/*Nouvelle classe pour Sprite dans le but de pouvoir passer des paramètres*/	
import flash.display.Sprite;
class Ext_sprite extends Sprite{
	public var vx:Number;
	public var vy:Number;
	public var stageX:Number;
	public var stageY:Number;
	public function Ext_sprite(){
		}
	}